/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (I)         *
 *            - ץߥ󥰤δá꥽٥ -             *
 *                                                                     *
 *      Copyright 1994,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define INTERVAL  (0.5 * 1000)  /* ॢȻ */
#define PIE       (60 * 64)     /* ߸(ѥ)γ */
#define ROTATION  (20 * 64)     /* ߸(ѥ)ž */

static void TimeoutCB();
static Widget canvas;  /* ߸(ѥ)ɥꥢå */
static XtIntervalId timeout_id;  /* ॢȡХå ID */
static GC gc;  /* եåƥ (Xlib ɬ) */
static int angle = (90 * 64) - PIE;  /* ǽα߸̤γϳ */

/* [] ܥ򲡤ȸƤӽФ */
static void StartCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget start = (Widget)w, stop  = (Widget)client_data;

    /* ॢȡХåϿ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(canvas),
                                 INTERVAL, TimeoutCB, NULL);
    XtSetSensitive(start, False);  /* [] ܥȤʤ */
    XtSetSensitive(stop, True);    /* [] ܥȤ褦ˤ */
}

/* ॢȡХå */
static void TimeoutCB(client_data, id)
    XtPointer     client_data;  /* ϿϤƤ饤ȡǡ */
    XtIntervalId *id;           /* ॢȡХå ID */
{
    XClearWindow(XtDisplay(canvas), XtWindow(canvas)); /* ɥ򥯥ꥢ */
    XFillArc(XtDisplay(canvas), XtWindow(canvas), gc,  /* ߸(ѥ) */
             50, 50, 100, 100, angle, PIE);
    /* ƤӥॢȡХåƤӽФ褦ˤ */
    timeout_id = XtAppAddTimeOut(XtWidgetToApplicationContext(canvas),
                                 INTERVAL, TimeoutCB, NULL);
    angle -= ROTATION;  /* ߸̤γϳ٤׻Ƥ */
    if (angle < 0) angle += (360 * 64);
}

/* [] ܥ򲡤ȸƤӽФ */
static void StopCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget start = (Widget)client_data, stop  = (Widget)w;

    /* ॢȡХå */
    XtRemoveTimeOut(timeout_id);

    XtSetSensitive(start, True);  /* [] ܥȤ褦ˤ */
    XtSetSensitive(stop, False);  /* [] ܥȤʤ */
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, bboard, control, start, stop;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Timeoutcb", NULL, 0,
                               &argc, argv, NULL, al, ac);
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    bboard = XmCreateBulletinBoard(panel, "bboard", al, ac);
    XtManageChild(bboard);

    ac = 0;
    canvas = XmCreateDrawingArea(bboard, "canvas", al, ac);
    XtManageChild(canvas);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    ac = 0;
    start = XmCreatePushButton(control, "start", al, ac);
    XtManageChild(start);

    ac = 0;
    /* ǽ [] ܥȤʤƤ */
    XtSetArg(al[ac], XmNsensitive, False); ac++;
    stop = XmCreatePushButton(control, "stop", al, ac);
    XtManageChild(stop);

    XtAddCallback(start, XmNactivateCallback, StartCB, stop);
    XtAddCallback(stop, XmNactivateCallback, StopCB, start);

    XtRealizeWidget(toplevel);

    /* եåƥȤ޷ο */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XSetForeground(XtDisplay(canvas), gc, BlackPixelOfScreen(XtScreen(canvas)));

    XtAppMainLoop(app_context);
}
