/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (I)         *
 *            - ץߥ󥰤δá꥽٥ -             *
 *                                                                     *
 *      Copyright 1994,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>
#include <X11/cursorfont.h>  /* "?" ޡΥκɬ */

static Widget toplevel;
static Widget dialog;
static Cursor question;

/* ֥եץ˥塼ιܤФ줿ȤΥХå */
static void FileMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    int menu_item = (int)client_data;  /* Ф줿˥塼ܤֹ */
    printf("File Menu: item %d is selected\n", menu_item);

    if (menu_item == 3)  /* 3 ܤΥ˥塼 (ֽλ) ʤ */
        exit(0);         /* ץλ */
}

/* ֥إסץ˥塼ιܤФ줿ȤΥХå */
static void HelpMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget   context;
    XEvent   event;
    char     string[BUFSIZ];
    XmString message;

    int menu_item = (int)client_data;  /* Ф줿˥塼ܤֹ */
    printf("Help Menu: item %d is selected\n", menu_item);

    if (menu_item == 0) {  /* ˥塼ֹ 0 ϡ֥ƥȡץإ */
        /* ٥Ȥꤷơ桼˥åȤФ */
        context = XmTrackingEvent(toplevel, question, False, &event);
        if (context == NULL)                /* ʤ */
            XBell(XtDisplay(toplevel), 0);  /* ٥Ĥ餷ƹ */
        else {
            /* إסåʸ */
            sprintf(string, "Help message for widget `%s'", XtName(context));
            /* ʸ򥳥ѥɡȥ󥰤Ѵ */
            message = XmStringCreateLocalized(string);
            /* å */
            XtVaSetValues(dialog, XmNmessageString, message, NULL);
            XmStringFree(message); /* פʥѥɡȥ󥰤 */
            XtManageChild(dialog); /* ̤˽Ф */
        }
    }
}

/* Ф줿ƥȤ򥯥åץܡɤ˥ԡ */
static void CopyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextCopy(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* Ф줿ƥȤ򥯥åץܡɤ˥å */
static void CutCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextCut(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* åץܡɤΥǡƥȤ˥ڡ */
static void PasteCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    XmTextPaste(text);
}

/* ˥塼Сȥץ󡦥˥塼 */
static Widget CreateMenu(parent)
    Widget parent;
{
    Widget  menubar, filemenu, helpbutton, helpmenu;
    Arg     al[20];
    int     ac;
    int     n = 0;

    /* ˥塼С */
    menubar = XmVaCreateSimpleMenuBar(parent, "menubar",
                XmVaCASCADEBUTTON, NULL, NULL,  /* ֥եץ˥塼 */
                NULL);
    XtManageChild(menubar);

    /* ֥եץץ󡦥˥塼 */
    filemenu = XmVaCreateSimplePulldownMenu(menubar, "filemenu",
                  n++, FileMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֿ */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֥ץ */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ݴɡ */
                  XmVaSEPARATOR,  /* ѥ졼 (˥塼ܤζڤ) */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֽλ */
                  NULL);

    /* ֥إסץ˥塼Υܥ */
    ac = 0;
    helpbutton = XmCreateCascadeButtonGadget(menubar, "helpbutton", al, ac);
    XtManageChild(helpbutton);

    /* ֥إסץ˥塼˥塼Сαü֤ */
    XtVaSetValues(menubar, XmNmenuHelpWidget, helpbutton, NULL);

    helpmenu = XmVaCreateSimplePulldownMenu(menubar, "helpmenu",
                  n++, HelpMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*֥ƥȡ*/
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*ֳס*/
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL, /*֥С*/
                  NULL);

    return(menubar);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  mainwin, menubar, work, text, command, copy, cut, paste;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Contexthelp", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    dialog = XmCreateInformationDialog(toplevel, "dialog", al, ac);
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(dialog, XmDIALOG_HELP_BUTTON));

    ac = 0;
    XtSetArg(al[ac], XmNshowSeparator, True); ac++;
    XtSetArg(al[ac], XmNcommandWindowLocation, XmCOMMAND_BELOW_WORKSPACE); ac++;
    mainwin = XmCreateMainWindow(toplevel, "mainwin", al, ac);
    XtManageChild(mainwin);

    menubar = CreateMenu(mainwin);   /* ˥塼 */

    ac = 0;
    work = XmCreateRowColumn(mainwin, "work", al, ac);
    XtManageChild(work);

    ac = 0;
    command = XmCreateRowColumn(mainwin, "command", al, ac);
    XtManageChild(command);

    XmMainWindowSetAreas(mainwin, menubar, command, NULL, NULL, work);

    ac = 0;
    text = XmCreateText(work, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    copy = XmCreatePushButton(command, "copy", al, ac);
    XtManageChild(copy);
    ac = 0;
    cut = XmCreatePushButton(command, "cut", al, ac);
    XtManageChild(cut);
    ac = 0;
    paste = XmCreatePushButton(command, "paste", al, ac);
    XtManageChild(paste);

    XtAddCallback(copy,  XmNactivateCallback, CopyCB,  text);
    XtAddCallback(cut,   XmNactivateCallback, CutCB,   text);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);

    /* 졼ƥȤ˥󥹥ȡ */
    XtInstallAccelerators(text, copy);
    XtInstallAccelerators(text, cut);
    XtInstallAccelerators(text, paste);

    XtRealizeWidget(toplevel);

    /* "?" ޡΥ */
    question = XCreateFontCursor(XtDisplay(toplevel), XC_question_arrow);

    XtAppMainLoop(app_context);
}
